if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Player Brick Limit","Brick Limit","$Pref::Server::PlayerBrickLimit","string 6","Server_PlayerBrickLimit",-1,0,1);
	RTB_registerPref("Admin Bypass Level","Brick Limit","$Pref::Server::AdminBrickLevel","list Player 0 Admin 1 SuperAdmin 2 Host 3 None 4","Server_PlayerBrickLimit",4,0,1);
}
else if($Pref::Server::PlayerBrickLimit $= "")
{
	$Pref::Server::PlayerBrickLimit = -1;
	$Pref::Server::AdminBrickLevel = 4;
	messageAll('',"Type /AdjustLimits for player brick limit information.");
}

function serverCmdAdjustLimits(%client,%limit,%AL)
{
	if(%client.getAdminLevel() != 3)
		return;
	if(!%limit)
	{
		messageClient(%client,'',"/AdjustLimits BrickCount AdminLevel");
		messageClient(%client,'',"Put -1 in BrickCount for unlimited. (Does not bypass Demo limit)");
		messageClient(%client,'',"Admin levels: Player = 0, Admin = 1, SuperAdmin = 2, Host = 3");
		messageClient(%client,'',"Admin level allows you to bypass the player brick limit. (Does not bypass Demo limit) Set to 4 to allow no one to bypass.");
		messageClient(%client,'','Current Limit: %1, Admin level: %2',$Pref::Server::PlayerBrickLimit,$Pref::Server::AdminBrickLevel);
	}
	else
	{
		$Pref::Server::PlayerBrickLimit = %limit/1;
		if(%AL)
			$Pref::Server::AdminBrickLevel = %AL;
		messageAll(%client,'MsgAdminForce','\c3%2 \c2has changed the brick limit to \c4%1.', $Pref::server::PlayerBrickLimit, %client.name);
	}
}

package PBrickLimit
{
	function serverCmdPlantBrick(%client)
	{
		if(%client.brickGroup.getCount()-isObject(%client.player.tempbrick) < $Pref::Server::PlayerBrickLimit || %client.getAdminLevel() >= $Pref::Server::AdminBrickLevel || $Pref::Server::PlayerBrickLimit == -1)
			Parent::serverCmdPlantBrick(%client);
		if($Pref::Server::PlayerBrickLimit != -1)
			%client.centerPrint("<just:right><color:ffffff>Bricks: " @ %client.brickGroup.getCount()-isObject(%client.player.tempbrick) @ "/" @ $Pref::Server::PlayerBrickLimit);
		else
			%client.centerPrint("<just:right><color:ffffff>Bricks: " @ %client.brickGroup.getCount()-isObject(%client.player.tempbrick),3);
	}
};

activatePackage(PBrickLimit);

function GameConnection::getAdminLevel(%this)
{
	if(%this.isLocalConnection() || %this.bl_id == getNumKeyID())
		return 3;
	else if(%this.isSuperAdmin)
		return 2;
	else if(%this.isAdmin)
		return 1;
	else
		return 0;
}